<template>

  <v-container fluid>

    <v-card-actions>
      <v-spacer />
      <v-text-field
        name="Profesor-text" label="Búsqueda" v-model="profesores.tabla.busqueda"
        style="border-radius: 10px; max-width: 300px;" clearable dense
        prepend-inner-icon="mdi-account-search" outlined color="white"
      />
    </v-card-actions>

    <v-card>

      <v-data-table
        :headers="profesores.tabla.headers" :items="profesores.listado" class="elevation-0"
        hide-default-footer :items-per-page="profesores.tabla.profesoresPorPagina"
        :page.sync="profesores.tabla.pagina" @page-count="profesores.tabla.conteoPaginas = $event"
        :loading="profesores.tabla.loading" :custom-filter="Busqueda" :search="profesores.tabla.busqueda"
        loading-text="Cargando... por favor espere"
      >

        <template v-slot:no-data>

          <v-alert prominent type="info" color="blue darken-1">
            No hay profesores disponibles para mostrar en este momento, vuelva a intentarlo.
          </v-alert>

        </template>

        <template v-slot:no-results>

          <v-alert prominent type="info" color="blue darken-1">
            No hay resultados encontrados con la búsqueda "{{ profesores.tabla.busqueda }}".
          </v-alert>

        </template>

        <template v-slot:top>

          <v-toolbar height="80" flat style="border-radius: 10px;">
            <v-toolbar-title>
              Administrar profesores
            </v-toolbar-title>
            <v-spacer />
            <v-btn color="blue darken-1" @click="MostrarDialogoNuevoProfesor">
              <v-icon left size="25">mdi-plus</v-icon>
              Nuevo Profesor
            </v-btn>
          </v-toolbar>

        </template>

        <template v-slot:[`item.genero`] = "{ item }">

          <span v-if="item.genero === 'M'"> Masculino </span>
          <span v-else> Femenino </span>

        </template>

        <template v-slot:[`item.acciones`] = "{ item }">

          <v-tooltip bottom>
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                color="amber darken-1" dark v-bind="attrs" v-on="on"
                @click="MostrarDialogoEditarProfesor(item)" icon
              >

                <v-icon> mdi-pencil </v-icon>

              </v-btn>
            </template>
            <span>Editar Profesor</span>
          </v-tooltip>

          <v-tooltip bottom>
            <template v-slot:activator="{ on, attrs }">
              <v-btn
                color="error" dark v-bind="attrs" v-on="on"
                @click="EliminarProfesor(item)" icon
              >

                <v-icon> mdi-delete </v-icon>

              </v-btn>
            </template>
            <span>Eliminar Profesor</span>
          </v-tooltip>

        </template>

      </v-data-table>

      <v-divider/>

      <v-pagination
        class="py-3" v-model="profesores.tabla.pagina"
        :length="profesores.tabla.conteoPaginas" total-visible="10"
      >

      </v-pagination>

    </v-card>

    <NuevoEditarProfesor
      v-model="dialogos.profesor" :profesor.sync="profesores.seleccionado"
      @refresh="Obtenerprofesores"
    />

  </v-container>

</template>


<script>

import NuevoEditarProfesor from "~/components/profesores/NuevoEditarProfesor";

export default {

  components: { NuevoEditarProfesor },

  mounted() {

    this.Obtenerprofesores()

  },

  data(){

    return {

      dialogos: {

        profesor: false

      },

      profesores: {

        listado: [],
        seleccionado: {},
        tabla: {

          headers: [
            { text: 'ID', value: 'idProfesor', align: 'center' },
            { text: 'Nombre', value: 'nombre', align: 'center' },
            { text: 'Apellido', value: 'apellidos', align: 'center' },
            { text: 'Género', value: 'genero', align: 'center' },
            { text: 'Acciones', value: 'acciones', align: 'center' },
          ],
          busqueda: null,
          loading: false,
          pagina: 1,
          conteoPaginas: 0,
          profesoresPorPagina: 10

        }

      }

    }

  },

  methods: {

    async Obtenerprofesores(){

      this.profesores.tabla.loading = true

      let config = { timeout: 5000 }

      await this.$axios.get("/profesores", config).then(({data}) => {

        this.profesores.listado = data
        this.profesores.tabla.loading = false

      })

    },

    async EliminarProfesor(profesor){

      let config = { timeout: 5000 }

      await this.$axios.post("/profesores/eliminar/" + profesor.idProfesor, {}, config).then(({data}) => {

        this.Obtenerprofesores()

      })

    },

    Busqueda(value, search, item){

      let nombre = RegExp(search, 'i').test(item.nombre)
      let apellidos = RegExp(search, 'i').test(item.apellidos)

      return nombre | apellidos

    },

    MostrarDialogoNuevoProfesor(){

      this.dialogos.profesor = true

    },

    MostrarDialogoEditarProfesor(profesor){

      this.profesores.seleccionado = Object.assign({}, profesor)
      this.dialogos.profesor = true

    }

  }

}

</script>
